var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: !0, configurable: !0, writable: !0, value }) : obj[key] = value;
var __name = (target, value) => __defProp(target, "name", { value, configurable: !0 });
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key != "symbol" ? key + "" : key, value);
import { Disposable, CommandType } from "@univerjs/core";
import { BehaviorSubject } from "rxjs";
const CROSSHAIR_HIGHLIGHT_COLORS = [
  "rgba(158, 109, 227, 0.3)",
  "rgba(254, 75, 75, 0.3)",
  "rgba(255, 140, 81, 0.3)",
  "rgba(164, 220, 22, 0.3)",
  "rgba(45, 174, 255, 0.3)",
  "rgba(58, 96, 247, 0.3)",
  "rgba(242, 72, 166, 0.3)",
  "rgba(153, 153, 153, 0.3)",
  "rgba(158, 109, 227, 0.15)",
  "rgba(254, 75, 75, 0.15)",
  "rgba(255, 140, 81, 0.15)",
  "rgba(164, 220, 22, 0.15)",
  "rgba(45, 174, 255, 0.15)",
  "rgba(58, 96, 247, 0.15)",
  "rgba(242, 72, 166, 0.15)",
  "rgba(153, 153, 153, 0.15)"
], _SheetsCrosshairHighlightService = class _SheetsCrosshairHighlightService extends Disposable {
  constructor() {
    super(...arguments);
    __publicField(this, "_enabled$", new BehaviorSubject(!1));
    __publicField(this, "enabled$", this._enabled$.asObservable());
    __publicField(this, "_color$", new BehaviorSubject(CROSSHAIR_HIGHLIGHT_COLORS[0]));
    __publicField(this, "color$", this._color$.asObservable());
  }
  get enabled() {
    return this._enabled$.getValue();
  }
  get color() {
    return this._color$.getValue();
  }
  dispose() {
    this._enabled$.complete();
  }
  setEnabled(value) {
    this._enabled$.next(value);
  }
  setColor(value) {
    this._color$.next(value);
  }
};
__name(_SheetsCrosshairHighlightService, "SheetsCrosshairHighlightService");
let SheetsCrosshairHighlightService = _SheetsCrosshairHighlightService;
const ToggleCrosshairHighlightOperation = {
  id: "sheet.operation.toggle-crosshair-highlight",
  type: CommandType.OPERATION,
  handler(accessor) {
    const service = accessor.get(SheetsCrosshairHighlightService), turnedOn = service.enabled;
    return service.setEnabled(!turnedOn), !0;
  }
}, SetCrosshairHighlightColorOperation = {
  id: "sheet.operation.set-crosshair-highlight-color",
  type: CommandType.OPERATION,
  handler(accessor, { value }) {
    const service = accessor.get(SheetsCrosshairHighlightService);
    return service.enabled || service.setEnabled(!0), service.setColor(value), !0;
  }
}, EnableCrosshairHighlightOperation = {
  id: "sheet.operation.enable-crosshair-highlight",
  type: CommandType.OPERATION,
  handler(accessor) {
    const service = accessor.get(SheetsCrosshairHighlightService);
    return service.enabled ? !1 : (service.setEnabled(!0), !0);
  }
}, DisableCrosshairHighlightOperation = {
  id: "sheet.operation.disable-crosshair-highlight",
  type: CommandType.OPERATION,
  handler(accessor) {
    const service = accessor.get(SheetsCrosshairHighlightService);
    return service.enabled ? (service.setEnabled(!1), !0) : !1;
  }
};
export {
  CROSSHAIR_HIGHLIGHT_COLORS as C,
  DisableCrosshairHighlightOperation as D,
  EnableCrosshairHighlightOperation as E,
  SheetsCrosshairHighlightService as S,
  ToggleCrosshairHighlightOperation as T,
  SetCrosshairHighlightColorOperation as a
};
